---
title: Element.insertAdjacentText()
slug: Web/API/Element/insertAdjacentText
tags:
  - API
  - DOM
  - Element
  - Gecko
  - Method
  - Reference
  - insertAdjacentText
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>insertAdjacentText()</code></strong> method of the {{domxref("Element")}} interface inserts a given text node at a given position relative to the element it is invoked upon.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>element</em>.insertAdjacentText(<em>position</em>, <em>element</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>position</code></dt>
 <dd>A {{domxref("DOMString")}} representing the position relative to the <code>element</code>; must be one of the following strings:
 <ul>
  <li><code style="color: red;">'beforebegin'</code>: Before the <code>element</code> itself.</li>
  <li><code style="color: green;">'afterbegin'</code>: Just inside the <code>element</code>, before its first child.</li>
  <li><code style="color: blue;">'beforeend'</code>: Just inside the <code>element</code>, after its last child.</li>
  <li><code style="color: magenta;">'afterend'</code>: After the <code>element</code> itself.</li>
 </ul>
 </dd>
 <dt><code>element</code></dt>
 <dd>A {{domxref("DOMString")}} representing the text to be inserted into the tree.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Void.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>SyntaxError</code></td>
   <td>The <code>position</code> specified is not a recognised value.</td>
  </tr>
 </tbody>
</table>

<h3 id="Visualization_of_position_names">Visualization of position names</h3>

<pre>&lt;!-- <strong><code style="color: red;">beforebegin</code></strong> --&gt;
<code style="font-weight: bold;">&lt;p&gt;</code>
  &lt;!-- <strong><code style="color: green;">afterbegin</code></strong> --&gt;
  foo
  &lt;!-- <strong><code style="color: blue;">beforeend</code></strong> --&gt;
<code style="font-weight: bold;">&lt;/p&gt;</code>
&lt;!-- <strong><code style="color: magenta;">afterend</code></strong> --&gt;</pre>

<div class="note"><strong>Note:</strong> The <code>beforebegin</code> and <code>afterend</code> positions work only if the node is in a tree and has an element parent.</div>

<h2 id="Example">Example</h2>

<pre class="brush: js">beforeBtn.addEventListener('click', function() {
  para.insertAdjacentText('afterbegin',textInput.value);
});

afterBtn.addEventListener('click', function() {
  para.insertAdjacentText('beforeend',textInput.value);
});</pre>

<p>Have a look at our <a href="https://mdn.github.io/dom-examples/insert-adjacent/insertAdjacentText.html">insertAdjacentText.html</a> demo on GitHub (see the <a href="https://github.com/mdn/dom-examples/blob/master/insert-adjacent/insertAdjacentText.html">source code</a> too.) Here we have a simple paragraph. You can enter some text into the form element, then press the <em>Insert before</em> and <em>Insert after</em> buttons to insert it before or after the existing paragraph text using <code>insertAdjacentText()</code>. Note that the existing text node is not added to — further text nodes are created containing the new additions.</p>

<h2 id="Polyfill">Polyfill</h2>

<p>You can polyfill the insertAdjacentText<code>() method</code> in Internet Explorer 5.5 (maybe earlier) and higher with the following code:</p>

<pre>if (!Element.prototype.insertAdjacentText)
  Element.prototype.insertAdjacentText = function(type, txt){
    this.insertAdjacentHTML(
      type,
      (txt+'') // convert to string
        .replace(/&amp;/g, '&amp;amp;') // embed ampersand symbols
        .replace(/&lt;/g, '&amp;lt;') // embed less-than symbols
    )
  }
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-element-insertadjacenttext', 'insertAdjacentText()')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.insertAdjacentText")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Element.insertAdjacentElement()")}}</li>
 <li>{{domxref("Element.insertAdjacentHTML()")}}</li>
</ul>
